<template>
  <div class="container">
    <div class="section">
      <item-type-detail
        :loading="loading"
        :name.sync="name"
        :description.sync="description"
        @submit="submit"
        @cancel="$router.push({ name: 'itemType' })"
      />
    </div>
  </div>
</template>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';
  import { Repository } from '@/modals/itemType';

  @Component<ItemTypeCreatePage>({
    components: {
      ItemTypeDetail: () => import('@/components/itemType/ItemTypeDetail.vue'),
    },
  })
  export default class ItemTypeCreatePage extends Vue {
    name: string = '';
    description: string = '';
    loading: boolean = false;

    submit() {
      this.loading = true;
      return Repository.create({ name: this.name, description: this.description })
        .then(() => {
          this.$router.push({ name: 'itemType' });
        });
    }
  }
</script>
